#include "main.h"

//
// stristr (stolen from fts.c, wickn) 
//
// case-insensitive version of strstr 
// stristr returns a pointer to the first occurrence of string2 in string1.
// The search does not include terminating nul characters.
// 
char* stristr(const char* string1, const char* string2) {
	char *cp1 = (char*) string1, *cp2, *cp1a;
	char first;
	// get the first char in string to find
	first = string2[0];
	// first char often won't be alpha
	if (isalpha(first))
	{
		first = tolower(first);
		for ( ; *cp1  != '\0'; cp1++)
		{
			if (tolower(*cp1) == first)
			{
				for (cp1a = &cp1[1], cp2 = (char*) &string2[1];;cp1a++, cp2++)
				{
					if (*cp2 == '\0')
						return cp1;
					if (tolower(*cp1a) != tolower(*cp2))
						break;
                 }
             }
         }
     }
	else
	{
		for ( ; *cp1 != '\0' ; cp1++)
		{
			if (*cp1 == first)
			{
				for (cp1a = &cp1[1], cp2 = (char*) &string2[1];;cp1a++, cp2++)
				{
					if (*cp2 == '\0')
						return cp1;
					if (tolower(*cp1a) != tolower(*cp2))
						break;
                 }
             }
         }
     }
	return NULL;
 } 

